/* ArchiveFile.c generated by valac 0.40.6, the Vala compiler
 * generated from ArchiveFile.vala, do not modify */

/*
 * ArchiveFile.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */


#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>


#define TYPE_FILE_ITEM (file_item_get_type ())
#define FILE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FILE_ITEM, FileItem))
#define FILE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FILE_ITEM, FileItemClass))
#define IS_FILE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FILE_ITEM))
#define IS_FILE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FILE_ITEM))
#define FILE_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FILE_ITEM, FileItemClass))

typedef struct _FileItem FileItem;
typedef struct _FileItemClass FileItemClass;
typedef struct _FileItemPrivate FileItemPrivate;

#define TYPE_ARCHIVE_FILE (archive_file_get_type ())
#define ARCHIVE_FILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ARCHIVE_FILE, ArchiveFile))
#define ARCHIVE_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ARCHIVE_FILE, ArchiveFileClass))
#define IS_ARCHIVE_FILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ARCHIVE_FILE))
#define IS_ARCHIVE_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ARCHIVE_FILE))
#define ARCHIVE_FILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ARCHIVE_FILE, ArchiveFileClass))

typedef struct _ArchiveFile ArchiveFile;
typedef struct _ArchiveFileClass ArchiveFileClass;
typedef struct _ArchiveFilePrivate ArchiveFilePrivate;
enum  {
	ARCHIVE_FILE_0_PROPERTY,
	ARCHIVE_FILE_NUM_PROPERTIES
};
static GParamSpec* archive_file_properties[ARCHIVE_FILE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _FileItem {
	GObject parent_instance;
	FileItemPrivate * priv;
	gchar* file_name;
	gchar* file_location;
	gchar* file_path;
	gchar* file_path_prefix;
	GFileType file_type;
	GDateTime* modified;
	gchar* permissions;
	gchar* owner_user;
	gchar* owner_group;
	gchar* content_type;
	gchar* file_status;
	gboolean is_selected;
	gboolean is_symlink;
	gchar* symlink_target;
	gboolean is_archive;
	gboolean is_stale;
	FileItem* parent;
	GeeHashMap* children;
	FileItem* source_archive;
	GObject* tag;
	glong file_count;
	glong dir_count;
	glong file_count_total;
	glong dir_count_total;
	GIcon* icon;
	gboolean is_dummy;
};

struct _FileItemClass {
	GObjectClass parent_class;
};

struct _ArchiveFile {
	FileItem parent_instance;
	ArchiveFilePrivate * priv;
	gint64 archive_size;
	gint64 archive_unpacked_size;
	gdouble compression_ratio;
	gchar* archive_type;
	gchar* archive_method;
	gboolean archive_is_encrypted;
	gboolean archive_is_solid;
	gint archive_blocks;
	gint64 archive_header_size;
	GDateTime* archive_modified;
	gchar* password;
	gchar* keyfile;
	GeeArrayList* extract_list;
	gchar* temp_dir;
	gchar* script_file;
	gchar* log_file;
};

struct _ArchiveFileClass {
	FileItemClass parent_class;
};


static gpointer archive_file_parent_class = NULL;
extern gchar* tee_jee_process_helper_TEMP_DIR;

GType file_item_get_type (void) G_GNUC_CONST;
GType archive_file_get_type (void) G_GNUC_CONST;
ArchiveFile* archive_file_new (const gchar* archive_file_path);
ArchiveFile* archive_file_construct (GType object_type,
                                     const gchar* archive_file_path);
FileItem* file_item_new_from_path_and_type (const gchar* _file_path,
                                            GFileType _file_type);
FileItem* file_item_construct_from_path_and_type (GType object_type,
                                                  const gchar* _file_path,
                                                  GFileType _file_type);
gchar* tee_jee_misc_timestamp_for_path (void);
gboolean tee_jee_file_system_dir_create (const gchar* dir_path,
                                         gboolean show_message);
void archive_file_add_items (ArchiveFile* self,
                             GeeArrayList* item_list);
FileItem* file_item_add_child_from_disk (FileItem* self,
                                         const gchar* item_file_path,
                                         gint depth);
static void archive_file_finalize (GObject * obj);


ArchiveFile*
archive_file_construct (GType object_type,
                        const gchar* archive_file_path)
{
	ArchiveFile * self = NULL;
	GeeArrayList* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_;
#line 62 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	g_return_val_if_fail (archive_file_path != NULL, NULL);
#line 63 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	self = (ArchiveFile*) file_item_construct_from_path_and_type (object_type, archive_file_path, G_FILE_TYPE_REGULAR);
#line 64 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	((FileItem*) self)->is_archive = TRUE;
#line 68 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 68 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	_g_object_unref0 (self->extract_list);
#line 68 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	self->extract_list = _tmp0_;
#line 69 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	_tmp1_ = tee_jee_process_helper_TEMP_DIR;
#line 69 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	_tmp2_ = g_strconcat (_tmp1_, "/", NULL);
#line 69 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	_tmp3_ = _tmp2_;
#line 69 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	_tmp4_ = tee_jee_misc_timestamp_for_path ();
#line 69 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	_tmp5_ = _tmp4_;
#line 69 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	_tmp6_ = g_strconcat (_tmp3_, _tmp5_, NULL);
#line 69 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	_g_free0 (self->temp_dir);
#line 69 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	self->temp_dir = _tmp6_;
#line 69 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	_g_free0 (_tmp5_);
#line 69 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	_g_free0 (_tmp3_);
#line 70 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	_tmp7_ = self->temp_dir;
#line 70 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	_tmp8_ = g_strconcat (_tmp7_, "/log.txt", NULL);
#line 70 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	_g_free0 (self->log_file);
#line 70 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	self->log_file = _tmp8_;
#line 71 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	_tmp9_ = self->temp_dir;
#line 71 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	_tmp10_ = g_strconcat (_tmp9_, "/convert.sh", NULL);
#line 71 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	_g_free0 (self->script_file);
#line 71 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	self->script_file = _tmp10_;
#line 72 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	_tmp11_ = self->temp_dir;
#line 72 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	tee_jee_file_system_dir_create (_tmp11_, FALSE);
#line 62 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	return self;
#line 225 "ArchiveFile.c"
}


ArchiveFile*
archive_file_new (const gchar* archive_file_path)
{
#line 62 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	return archive_file_construct (TYPE_ARCHIVE_FILE, archive_file_path);
#line 234 "ArchiveFile.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 77 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	return self ? g_object_ref (self) : NULL;
#line 243 "ArchiveFile.c"
}


void
archive_file_add_items (ArchiveFile* self,
                        GeeArrayList* item_list)
{
	gint _tmp0_;
	gint _tmp1_;
#line 75 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	g_return_if_fail (self != NULL);
#line 75 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	g_return_if_fail (item_list != NULL);
#line 76 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	_tmp0_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) item_list);
#line 76 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	_tmp1_ = _tmp0_;
#line 76 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	if (_tmp1_ > 0) {
#line 263 "ArchiveFile.c"
		{
			GeeArrayList* _item_list = NULL;
			GeeArrayList* _tmp2_;
			gint _item_size = 0;
			GeeArrayList* _tmp3_;
			gint _tmp4_;
			gint _tmp5_;
			gint _item_index = 0;
#line 77 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
			_tmp2_ = _g_object_ref0 (item_list);
#line 77 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
			_item_list = _tmp2_;
#line 77 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
			_tmp3_ = _item_list;
#line 77 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
			_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 77 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
			_tmp5_ = _tmp4_;
#line 77 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
			_item_size = _tmp5_;
#line 77 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
			_item_index = -1;
#line 77 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
			while (TRUE) {
#line 288 "ArchiveFile.c"
				gint _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
				gchar* item = NULL;
				GeeArrayList* _tmp9_;
				gint _tmp10_;
				gpointer _tmp11_;
				const gchar* _tmp12_;
				FileItem* _tmp13_;
				FileItem* _tmp14_;
#line 77 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
				_tmp6_ = _item_index;
#line 77 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
				_item_index = _tmp6_ + 1;
#line 77 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
				_tmp7_ = _item_index;
#line 77 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
				_tmp8_ = _item_size;
#line 77 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
				if (!(_tmp7_ < _tmp8_)) {
#line 77 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
					break;
#line 311 "ArchiveFile.c"
				}
#line 77 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
				_tmp9_ = _item_list;
#line 77 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
				_tmp10_ = _item_index;
#line 77 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
				_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _tmp10_);
#line 77 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
				item = (gchar*) _tmp11_;
#line 78 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
				_tmp12_ = item;
#line 78 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
				_tmp13_ = file_item_add_child_from_disk ((FileItem*) self, _tmp12_, -1);
#line 78 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
				_tmp14_ = _tmp13_;
#line 78 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
				_g_object_unref0 (_tmp14_);
#line 77 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
				_g_free0 (item);
#line 331 "ArchiveFile.c"
			}
#line 77 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
			_g_object_unref0 (_item_list);
#line 335 "ArchiveFile.c"
		}
	}
}


static void
archive_file_class_init (ArchiveFileClass * klass)
{
#line 37 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	archive_file_parent_class = g_type_class_peek_parent (klass);
#line 37 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	G_OBJECT_CLASS (klass)->finalize = archive_file_finalize;
#line 348 "ArchiveFile.c"
}


static void
archive_file_instance_init (ArchiveFile * self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
#line 40 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	self->archive_size = (gint64) 0;
#line 41 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	self->archive_unpacked_size = (gint64) 0;
#line 42 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	self->compression_ratio = 0.0;
#line 43 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	_tmp0_ = g_strdup ("");
#line 43 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	self->archive_type = _tmp0_;
#line 44 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	_tmp1_ = g_strdup ("");
#line 44 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	self->archive_method = _tmp1_;
#line 45 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	self->archive_is_encrypted = FALSE;
#line 46 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	self->archive_is_solid = FALSE;
#line 47 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	self->archive_blocks = 0;
#line 48 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	self->archive_header_size = (gint64) 0;
#line 51 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	_tmp2_ = g_strdup ("");
#line 51 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	self->password = _tmp2_;
#line 52 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	_tmp3_ = g_strdup ("");
#line 52 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	self->keyfile = _tmp3_;
#line 58 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	_tmp4_ = g_strdup ("");
#line 58 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	self->temp_dir = _tmp4_;
#line 59 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	_tmp5_ = g_strdup ("");
#line 59 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	self->script_file = _tmp5_;
#line 60 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	_tmp6_ = g_strdup ("");
#line 60 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	self->log_file = _tmp6_;
#line 404 "ArchiveFile.c"
}


static void
archive_file_finalize (GObject * obj)
{
	ArchiveFile * self;
#line 37 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ARCHIVE_FILE, ArchiveFile);
#line 43 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	_g_free0 (self->archive_type);
#line 44 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	_g_free0 (self->archive_method);
#line 49 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	_g_date_time_unref0 (self->archive_modified);
#line 51 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	_g_free0 (self->password);
#line 52 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	_g_free0 (self->keyfile);
#line 55 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	_g_object_unref0 (self->extract_list);
#line 58 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	_g_free0 (self->temp_dir);
#line 59 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	_g_free0 (self->script_file);
#line 60 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	_g_free0 (self->log_file);
#line 37 "/builddir/build/BUILD/timeshift-18.6.1/src/Utility/ArchiveFile.vala"
	G_OBJECT_CLASS (archive_file_parent_class)->finalize (obj);
#line 434 "ArchiveFile.c"
}


GType
archive_file_get_type (void)
{
	static volatile gsize archive_file_type_id__volatile = 0;
	if (g_once_init_enter (&archive_file_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ArchiveFileClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) archive_file_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ArchiveFile), 0, (GInstanceInitFunc) archive_file_instance_init, NULL };
		GType archive_file_type_id;
		archive_file_type_id = g_type_register_static (TYPE_FILE_ITEM, "ArchiveFile", &g_define_type_info, 0);
		g_once_init_leave (&archive_file_type_id__volatile, archive_file_type_id);
	}
	return archive_file_type_id__volatile;
}



